UNIT RSCOM2;

Interface
uses CRT;
var
  Wert      :    Byte;
  Ch        :    Char;

procedure Oeffnen;
procedure Schliessen;
procedure Senden  ( Wert : Byte );
procedure Empfangen ( var Wert : Byte );
procedure BusOut (Adresse,Datum : Byte);
procedure BusIn (Adresse : Byte; var Wert: Byte);

Implementation

procedure Oeffnen;
   var  Wert : Byte;
   begin
     Port [$2FB]:=128;          { Baudeingabe aktivieren    }
     Port [$2F8]:= 96;          { Baudrate - LSB, 1200 Baud }
     Port [$2F9]:=  0;          { Baudrate - MSB            }
     Port [$2FB]:=  3;          { 8 Bits, No Parity, 1 Stop }
     Port [$2FC]:=  3;          { DTR = 1, RTS = 1          }
     Wert := Port [$2F8]        { Empfangsregister leeren   }
   end;

procedure Schliessen;
   begin
     Port [$2FC]:=  0;          { DTR = 0, CTS = 0          }
   end;

procedure Senden  ( Wert : Byte );
   begin
     repeat
     until Port [$2FD] and 32 = 32;      { Abfrage, ob Sendepuffer leer }
     Port [$2F8]:= (Wert);               { Byte an Sendepuffer ausgeben }
   end;

procedure Empfangen ( var Wert : Byte );
   begin
     repeat until (Keypressed or
     ((Port [$2FD] and 1) = 1));        { Abfrage, ob Zeichen empfangen }
     Wert := Port [$2F8];               { Byte vom Empfangspuffer lesen }
   end;

procedure BusOut (Adresse,Datum : Byte);
   begin
     Senden (Adresse);
     Senden (Datum);
   end;

procedure BusIn (Adresse : Byte; var Wert: Byte);
   begin
     Adresse := Adresse + 128;
     Senden (Adresse);
     Empfangen (Wert);
   end;

begin
  Oeffnen
end.
