unit Serai18;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TSerai81 = class(TForm)
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Serai81: TSerai81;

implementation
const
 METHOD_BUFFERED    =             0;
 METHOD_IN_DIRECT   =             1;
 METHOD_OUT_DIRECT  =             2;
 METHOD_NEITHER     =             3;

const
 FILE_ANY_ACCESS     =           0;
 FILE_READ_ACCESS    =       $0001;     // file & pipe
 FILE_WRITE_ACCESS   =       $0002;     // file & pipe

const
 VXD_CTL_GET_VERSION   = $88902224 + 4;
 VXD_CTL_SCAN_START    = $88902224 + 8;
 VXD_CTL_DAQ_HALFREADY = $88902224 + 12;
 VXD_CTL_DAQ_TRANSFER  = $88902224 + 16;
 VXD_CTL_DAQ_CLEAR     = $88902224 + 20;
 VXD_CTL_DAQ_AI_SCAN   = $88902224 + 24;


var m_hCVxDSys, hComm: THandle;
    bHalfReady, bDAQstopped: Boolean;
    Buffer: Pchar;
    Buffer2: Array [0..4000] of Byte;



{$R *.DFM}


procedure DiagrammInit;
var n: Integer;
begin
  with Serai81.Paintbox1.Canvas do begin
  Pen.Color:=ClBlack;
  Brush.Color:=ClWhite;
  Rectangle(30,0,531,257);
  Pen.Color:=ClLtGray;
  for n:= 1 to 10 do begin
      MoveTo(31,256-n*25);
      Lineto (529,256-n*25);
  end;
  Brush.Color:=ClLtGray;
  for n:= 0 to 5 do begin
    TextOut(10,250-n*50,FloatToStr(n)+' V');
  end;
  for n:= 1 to 9 do begin
      MoveTo(30+50*n,254);
      Lineto (30+50*n,0)
  end;
  for n:= 1 to 10 do begin
    TextOut(20+50*n,260,FloatToStr(n*100));
  end;
  end;
end;

procedure Plot ;
var i: Integer;
begin
  with Serai81.Paintbox1.Canvas do begin
    Pen.Color:=ClBlack;
    MoveTo (31,256-Buffer2[1]);
    for i := 1 to 999 do
      LineTo (31+i div 2,256-Buffer2[i]);
  end;
end;

function CTL_Code (Devicetype: Dword; Func, Method,Access: Word) : Dword;
begin
  CTL_Code := (Devicetype shl 16) Or (Access shl 14) or (Func shl 2) or Method;
end;

procedure VxD_SyS_GetVersion (var Info: String);
var bFlag : Boolean;
    nReturned : DWord;
begin
    bFlag := DeviceIoControl ( m_hCVxDSys, VXD_CTL_GET_VERSION, Nil, 0, @Info, sizeof(INFO), nReturned, Nil );
end;


procedure ScanStart (wBaseAddress: Word; iNo: Word; iChannelPos: Word; count: Word; ms: Word );
 type _Parameter = record
      wBaseAddress: Word;
      iNo: Word;
      iChannelPos: Word;
      count: Word;
      ms: Word;
      Sleep: Word;
      iRetTreiber: Word;
 end;
 var Param : _Parameter;
 bFlag: Boolean;
 nReturned : DWord;

begin
    Param.wBaseAddress := wBaseAddress;
    Param.iNo := iNo;
    Param.iChannelPos := iChannelPos;
    Param.count := count;
    Param.ms := ms;
    Param.Sleep := 0;
    Param.iRetTreiber := 0;
    nReturned := 0;
    bFlag := DeviceIoControl( m_hCVxDSys, VXD_CTL_SCAN_START, @Param, sizeof(Param), @Param, sizeof(Param), nReturned, nil );
end;

procedure DAQ_HalfReady ( var bHalfReady: Boolean; var bDAQstopped: Boolean);
 type _Parameter = record
      bHalfReady: Boolean;
      bDAQstopped: Boolean;
      iRetTreiber: Word;
 end;
 var Param : _Parameter;
     bFlag : Boolean;
     nReturned : DWord;
 begin
   Param.bHalfReady	:= False;
   Param.bDAQstopped	:= False;
   Param.iRetTreiber	:= 0;
   nReturned := 0;
   bFlag := DeviceIoControl( m_hCVxDSys, VXD_CTL_DAQ_HALFREADY, @Param, sizeof(Param), @Param, sizeof(Param), nReturned, nil );

   bHalfReady := Param.bHalfReady;
   bDAQstopped := Param.bDAQstopped;
end;

procedure DAQ_Transfer (var Buffer: Pchar);
 type _Parameter = record
      pBuffer: Pointer;
      iRetTreiber: Word
 end;
 var Param : _Parameter;
     bFlag : Boolean;
     nReturned : DWord;
 begin
     Param.pBuffer := Buffer;
     Param.iRetTreiber := 0;
     nReturned := 0;
   bFlag := DeviceIoControl( m_hCVxDSys, VXD_CTL_DAQ_TRANSFER, @Param, sizeof(Param), @Param, sizeof(Param), nReturned, nil);
 end;

 procedure DAQ_Clear ( );
 type _Parameter = record
      iRetTreiber: Word
 end;
 var Param : _Parameter;
     bFlag : Boolean;
     nReturned : DWord;
 begin
   Param.iRetTreiber := 0;
   bFlag := DeviceIoControl( m_hCVxDSys, VXD_CTL_DAQ_CLEAR, @Param, sizeof(Param), @Param, sizeof(Param), nReturned, Nil);
 end;

procedure TSerai81.FormCreate(Sender: TObject);
begin
 DiagrammInit;
 getMem (Buffer, 10000);
 m_hCVxDSys := CreateFile('\\.\SERAI18.VxD', GENERIC_READ or GENERIC_WRITE,0,NIL,OPEN_EXISTING,0,0);
 hComm := CreateFile ( 'COM2:', GENERIC_READ or GENERIC_WRITE, 0, NIL, OPEN_EXISTING, 0, 0);
 ScanStart ($02F8, 1, 1, 1000, 1);
end;

procedure TSerai81.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 DAQ_Clear;
 CloseHandle (hComm);
 CloseHandle (m_hCVxDSys);
end;

procedure TSerai81.Timer1Timer(Sender: TObject);
var n: Integer;
begin
 DAQ_HalfReady (bHalfReady, bDAQstopped);
 if bHalfReady then begin;
    DAQ_Transfer (Buffer);
    for n:= 1 to 1000 do Buffer2[n] := ord (Buffer[4*n]);
    DiagrammInit;
    Plot;
 end;
end;

end.


/* ------------------------------------------------------------------------ */
/* COMx-Schnittstelle                                                       */
/* ------------------                                                       */
/* ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------ */
/* Funktionsname     : OpenComm                                             */
/* Hinweis           :                                                      */
/* Historie          : 01.09.1999 Mha (Erstellung)                          */
/* ------------------------------------------------------------------------ */

HANDLE AIModuleMicro_SerAD8::OpenComm ( LPCSTR port, UINT cbInQueue, UINT cbOutQueue )
{
   HANDLE hComm=INVALID_HANDLE_VALUE; char *qupos; char Text[40];

   /* Backslash vor 'COMx:' setzen und Doppelpunkt dahinter entfernen ... */
   /* "\\.\COMx"  dadurch knnen Schnittstellen ber COM9 geffnet werden */
   /* Das geht nur in der 32 Bit Version, darum hier eingefgt */
   strcpy ( Text, "\\\\.\\" );
   strcat ( Text, port);
   qupos = strrchr ( Text, ':' );
   if ( qupos != NULL )
      *qupos = '\0';

   hComm = CreateFile ( Text, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL );

   if ( hComm == INVALID_HANDLE_VALUE )
      return hComm;

   //SetupComm ( hComm, cbInQueue, cbOutQueue );
   UNUSED(cbInQueue);
   UNUSED(cbOutQueue);

   return hComm;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : FlushComm                                            */
/* Hinweis           :                                                      */
/* Historie          : 01.09.1999 Mha (Erstellung)                          */
/* ------------------------------------------------------------------------ */

int AIModuleMicro_SerAD8::FlushComm ( HANDLE hComm, int fnQueue )
{
   if ( fnQueue == 0 )
      PurgeComm ( hComm, PURGE_TXCLEAR );
   else
      PurgeComm ( hComm, PURGE_RXCLEAR );

   return 0;
}

/* ------------------------------------------------------------------------ */
/* Funktionsname     : CloseComm                                            */
/* Hinweis           :                                                      */
/* Historie          : 01.09.1999 Mha (Erstellung)                          */
/* ------------------------------------------------------------------------ */

int AIModuleMicro_SerAD8::CloseComm ( HANDLE hComm )
{
   return CloseHandle ( hComm );
}





end.
}

//////////////////////////////////////////////////////////////////////////////
//
// Define the various device type values.  Note that values used by Microsoft
// Corporation are in the range 0-32767, and 32768-65535 are reserved for use
// by customers.
//

#define FILE_DEVICE_VXD  0x08890

//
// Macro definition for defining IOCTL and FSCTL function control codes.  Note
// that function codes 0-2047 are reserved for Microsoft Corporation, and
// 2048-4095 are reserved for customers.
//

#define VXD_IOCTL_INDEX  0x0889


//////////////////////////////////////////////////////////////////////////////
// DeviceIoControl function codes for VxD driver

#define VXD_CODE(X) CTL_CODE(FILE_DEVICE_VXD, (VXD_IOCTL_INDEX+X), METHOD_BUFFERED, FILE_ANY_ACCESS)

#define VXD_CTL_GET_VERSION	VXD_CODE(1)
#define VXD_CTL_SCAN_START 	VXD_CODE(2)
#define VXD_CTL_DAQ_HALFREADY	VXD_CODE(3)
#define VXD_CTL_DAQ_TRANSFER    VXD_CODE(4)
#define VXD_CTL_DAQ_CLEAR       VXD_CODE(5)
#define VXD_CTL_DAQ_AI_SCAN     VXD_CODE(6)

#endif /* ndef _NT_DEF_H_ */

.... aus DevIOctl.h:

#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
)

//
// Define the method codes for how buffers are passed for I/O and FS controls
//

#define METHOD_BUFFERED                 0
#define METHOD_IN_DIRECT                1
#define METHOD_OUT_DIRECT               2
#define METHOD_NEITHER                  3

//
// Define the access check value for any access
//
//
// The FILE_READ_ACCESS and FILE_WRITE_ACCESS constants are also defined in
// ntioapi.h as FILE_READ_DATA and FILE_WRITE_DATA. The values for these
// constants *MUST* always be in sync.
//


#define FILE_ANY_ACCESS                 0
#define FILE_READ_ACCESS          ( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS         ( 0x0002 )    // file & pipe





end.

